//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
#include "TMainForm.h"
//---------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3 +
    #pragma package(smart_init)
#endif
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
#pragma link "TDx_Draw"
#pragma link "TDx_DrawSurface"
#pragma link "TDDCaps"
#pragma link "TDDPixelFormat"
#pragma link "TDDSCaps"
#pragma link "TDDSurfaceDesc"
#pragma link "TDx_Draw_Library_Install"
//---------------------------------------------------------------------------
TMainForm *MainForm;
//---------------------------------------------------------------------------
#define Msg(A)  {\
                if (StatusMemo->Text.Length()>30000) StatusMemo->Text = "";\
                StatusMemo->Lines->Add(A);\
                }
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMainForm::~TMainForm()
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
Width=780;
Height=580;
Position=poScreenCenter;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
if (Dx_Draw1->Created) Dx_Draw1->Destroy();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EnumerateButtonClick(TObject *Sender)
{
Msg("Scanning for Available Devices");

NumDevices = 0;
Dx_Draw1->DDEnumerate(NULL,0);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CreateDefaultButtonClick(TObject *Sender)
{
Msg("Creating Default Device");

if (Dx_Draw1->Created)
    Dx_Draw1->Destroy();

Dx_Draw1->Create(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CreateSelectedButtonClick(TObject *Sender)
{
Msg("Creating Selected Device");

if (Dx_Draw1->Created)
    Dx_Draw1->Destroy();

int index = DevicesListBox->ItemIndex;
Dx_Draw1->Create( Guids[index] );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DestroyActiveButtonClick(TObject *Sender)
{
Msg("Destroying Active Device");

if (Dx_Draw1->Created)
    {
    Dx_Draw1->SetCooperativeLevel( Application->Handle, DDSCL_NORMAL );
    Dx_Draw1->Destroy();
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RetrieveCapsButtonClick(TObject *Sender)
{
Msg("Retrieving Device Capabilities");
HelCapsListBox->Items->Clear();
DriverCapsListBox->Items->Clear();

if (Dx_Draw1->GetCaps( DriverCaps, HelCaps ))
    {
    // insert caps directly into listboxes
    HelCapsListBox->Items->AddStrings( HelCaps->Caps_Strings );
    DriverCapsListBox->Items->AddStrings( DriverCaps->Caps_Strings );

    // check for particular caps
    if (DriverCaps->Caps & DDCAPS_3D) Msg("Note: 3D Hardware Acceleration Available");
    if (DriverCaps->Caps & DDCAPS_BANKSWITCHED) Msg("Note: Display is Bank Switched Hardware: Slow");
    if (HelCaps->FXCaps & DDFXCAPS_BLTROTATION) Msg("Note: Hardware Emulation Layer supports Hardware Blit Rotation of arbitrary angle." );
    if (HelCaps->FXCaps & DDFXCAPS_BLTROTATION90) Msg("Note: Hardware Emulation Layer supports Hardware Blit Rotation of 90 degrees." );

    // The following code performs identically to the rows above,
    // except that instead of checking the 'public:' Caps property,
    // it is checking the '__published:' version of the Caps property, the vcl-style 'Caps_' property

//    if (DriverCaps->Caps_.Contains(ddcaps_3d)) Msg("Note: 3D Hardware Acceleration Available");
//    if (DriverCaps->Caps_.Contains(ddcaps_bankswitched)) Msg("Note: Display is Bank Switched Hardware: Slow");
//    if (HelCaps->FXCaps_.Contains(ddfxcaps_bltrotation)) Msg("Note: Hardware Emulation Layer supports Hardware Blit Rotation of arbitrary angle." );
//    if (HelCaps->FXCaps_.Contains(ddfxcaps_bltrotation90) Msg("Note: Hardware Emulation Layer supports Hardware Blit Rotation of 90 degrees." );
    }
else
    {
    HelCapsListBox->Items->Add( "------ Unknown ------" );
    DriverCapsListBox->Items->Add( "------ Unknown ------" );
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetCoopButtonClick(TObject *Sender)
{
Msg("Setting Fullscreen/Exclusive Mode");
Dx_Draw1->SetCooperativeLevel( Application->Handle, DDSCL_FULLSCREEN | DDSCL_EXCLUSIVE );
SetCoopButton->Enabled = false;
RestoreCoopButton->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RestoreCoopButtonClick(TObject *Sender)
{
Msg("Setting Normal Mode");
Dx_Draw1->SetCooperativeLevel( Application->Handle, DDSCL_NORMAL );
RestoreCoopButton->Enabled = false;
SetCoopButton->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ExitButtonClick(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ClearMessagesButtonClick(TObject *Sender)
{
StatusMemo->Lines->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DevicesListBoxClick(TObject *Sender)
{
if (DevicesListBox->Items->Count>0)
    {
    int index = DevicesListBox->ItemIndex;
    AnsiString device_name = DevicesListBox->Items->Strings[index];
    Msg("Device Selected: '"+device_name+"'");

    CreateSelectedButton->Enabled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1Create(TObject *Sender)
{
Msg("Device has been created");

EnumerateButton->Enabled = true;
CreateDefaultButton->Enabled = false;
CreateSelectedButton->Enabled = false;
DestroyActiveButton->Enabled = true;
RetrieveCapsButton->Enabled = true;
SetCoopButton->Enabled = true;
RestoreCoopButton->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1Destroy(TObject *Sender)
{
Msg("Device is being Destroyed");

EnumerateButton->Enabled = true;
CreateDefaultButton->Enabled = true;
CreateSelectedButton->Enabled = false;
DestroyActiveButton->Enabled = false;
RetrieveCapsButton->Enabled = false;
SetCoopButton->Enabled = false;
RestoreCoopButton->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1Error(TObject *Sender, AnsiString Function,
    AnsiString Error, AnsiString ErrorMessage)
{
Msg("ERROR ["+Error+"]: "+Function+", "+ErrorMessage);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1DDEnumerate(TObject *Sender, GUID *Guid,
    AnsiString DriverDescription, AnsiString DriverName, void *Context,
    HMONITOR HMonitor, bool &Finished)
{
if (NumDevices<MAX_DEVICES)
    {
    Guids[NumDevices] = Guid;
    Names[NumDevices] = DriverName;
    Descriptions[NumDevices] = DriverDescription;
    NumDevices++;

    Msg("Found a device: "+DriverName+", "+DriverDescription);
    DevicesListBox->Items->Add( DriverName+", "+DriverDescription );
    }
else
    Finished = true;
}
//---------------------------------------------------------------------------
