//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include "TMainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
#pragma link "TDx_Draw_Library_Install"
#pragma link "TDx_Draw"
#pragma link "TDx_DrawSurface"
#pragma link "TDDCaps"
#pragma link "TDDPixelFormat"
#pragma link "TDDSCaps"
#pragma link "TDDSurfaceDesc"
//---------------------------------------------------------------------------
TMainForm *MainForm;
//---------------------------------------------------------------------------
#define Msg(A)  {\
                if (StatusMemo->Text.Length()>30000) StatusMemo->Text = "";\
                StatusMemo->Lines->Add(A);\
                }
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
Width=780;
Height=580;
Position=poScreenCenter;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
if (Dx_Draw1->Created) Dx_Draw1->Destroy();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EnumerateButtonClick(TObject *Sender)
{
Msg("Scanning for Available Devices");
NumDevices = 0;
Dx_Draw1->DDEnumerate(NULL,0);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CreateDefaultButtonClick(TObject *Sender)
{
Msg("Creating Default Device");

if (Dx_Draw1->Created)
    Dx_Draw1->Destroy();

Dx_Draw1->Create(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CreateSelectedButtonClick(TObject *Sender)
{
Msg("Creating Selected Device");

if (Dx_Draw1->Created)
    Dx_Draw1->Destroy();

int index = DevicesListBox->ItemIndex;
Dx_Draw1->Create( Guids[index] );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DestroyActiveButtonClick(TObject *Sender)
{
Msg("Destroying Active Device");

if (Dx_Draw1->Created)
    {
    Dx_Draw1->SetCooperativeLevel( Application->Handle, DDSCL_NORMAL );
    Dx_Draw1->Destroy();
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EnumerateModesButtonClick(TObject *Sender)
{
Msg("Enumerating All Display Modes");
NumModes=0;
ModesListBox->Items->Clear();
Dx_Draw1->EnumDisplayModes(0,NULL,NULL);
if (NumModes==0)
    {
    Msg("Did not find any Display Modes");
    ModesListBox->Items->Add( "-- none --" );
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Enumerate800ModesButtonClick(TObject *Sender)
{
Msg("Enumerating 800x600x8 Display Modes");
DDSurfaceDesc1->Clear();
DDSurfaceDesc1->Flags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
DDSurfaceDesc1->Width = 800;
DDSurfaceDesc1->Height = 600;
DDSurfaceDesc1->PixelFormat = DDPixelFormat1;
DDSurfaceDesc1->PixelFormat->Flags[0] = DDPF_PALETTEINDEXED8;

NumModes=0;
ModesListBox->Items->Clear();
Dx_Draw1->EnumDisplayModes( DDEDM_REFRESHRATES, DDSurfaceDesc1, NULL );
if (NumModes==0)
    {
    Msg("Did not find any 640x480x8 modes");
    ModesListBox->Items->Add( "-- none --" );
    }
else Msg("Found "+IntToStr(NumModes)+" different 800x600x8 Display Modes");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetModeButtonClick(TObject *Sender)
{
if (ModesListBox->Items->Count>0)
    {
    ShowMessage("Please Note:\n\
You may experience difficulty restoring your display mode.\n\
To return to the original display mode at any time, press ALT-R (Restore) or ALT-X (eXit)" );

    RestoreModeButton->Enabled = true;

    int index = ModesListBox->ItemIndex;
    Dx_Draw1->SetDisplayMode( Widths[index], Heights[index], BitDepths[index], RefreshRates[index], 0 );

    Top=0;
    Left=0;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RestoreModeButtonClick(TObject *Sender)
{
Msg("Restoring Display Mode");
Dx_Draw1->RestoreDisplayMode();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ClearButtonClick(TObject *Sender)
{
StatusMemo->Lines->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ExitButtonClick(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DevicesListBoxClick(TObject *Sender)
{
if (DevicesListBox->Items->Count>0)
    {
    int index = DevicesListBox->ItemIndex;
    AnsiString device_name = DevicesListBox->Items->Strings[index];
    Msg("Device Selected: '"+device_name+"'");

    CreateSelectedButton->Enabled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ModesListBoxClick(TObject *Sender)
{
if (ModesListBox->Items->Count>0)
    {
    Msg("Mode Selected");
    SetModeButton->Enabled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1Create(TObject *Sender)
{
Msg("Device has been created");

Msg("Setting Fullscreen/Exclusive Mode");
Dx_Draw1->SetCooperativeLevel( Application->Handle, DDSCL_FULLSCREEN | DDSCL_EXCLUSIVE );

EnumerateButton->Enabled = true;
CreateDefaultButton->Enabled = false;
CreateSelectedButton->Enabled = false;
DestroyActiveButton->Enabled = true;
EnumerateModesButton->Enabled = true;
Enumerate800ModesButton->Enabled = true;
SetModeButton->Enabled = false;
RestoreModeButton->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1Destroy(TObject *Sender)
{
Msg("Device is being Destroyed");

Msg("Setting Normal Mode");
Dx_Draw1->SetCooperativeLevel( Application->Handle, DDSCL_NORMAL );

EnumerateButton->Enabled = true;
CreateDefaultButton->Enabled = true;
CreateSelectedButton->Enabled = false;
DestroyActiveButton->Enabled = false;
EnumerateModesButton->Enabled = false;
Enumerate800ModesButton->Enabled = false;
SetModeButton->Enabled = false;
RestoreModeButton->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1Error(TObject *Sender, AnsiString Function,
    AnsiString Error, AnsiString ErrorMessage)
{
Msg("ERROR ["+Error+"]: "+Function+", "+ErrorMessage);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1DDEnumerate(TObject *Sender, GUID *Guid,
    AnsiString DriverDescription, AnsiString DriverName, void *Context,
    HMONITOR HMonitor, bool &Finished)
{
if (NumDevices<MAX_DEVICES)
    {
    Guids[NumDevices] = Guid;
    Names[NumDevices] = DriverName;
    Descriptions[NumDevices] = DriverDescription;
    NumDevices++;

    Msg("Found a device: "+DriverName+", "+DriverDescription);
    DevicesListBox->Items->Add( DriverName+", "+DriverDescription );
    }
else
    Finished = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1EnumDisplayModes(TObject *Sender,
    TDDSurfaceDesc *SurfaceDesc, void *Context, bool &Finished)
{
int width = SurfaceDesc->Width;
int height = SurfaceDesc->Height;
int refresh_rate = SurfaceDesc->RefreshRate;
int bit_depth;

if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_PALETTEINDEXED1) bit_depth = 1;
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_PALETTEINDEXED2) bit_depth = 2;
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_PALETTEINDEXED4) bit_depth = 4;
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_PALETTEINDEXED8) bit_depth = 8;
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_PALETTEINDEXEDTO8) bit_depth = 8;
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_ALPHA) bit_depth = SurfaceDesc->PixelFormat->AlphaBitDepth[0];
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_ALPHAPIXELS) bit_depth = SurfaceDesc->PixelFormat->AlphaBitDepth[0];
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_ALPHAPREMULT) bit_depth = SurfaceDesc->PixelFormat->AlphaBitDepth[0];
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_BUMPDUDV) bit_depth = SurfaceDesc->PixelFormat->BumpBitCount[0];
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_BUMPLUMINANCE) bit_depth = SurfaceDesc->PixelFormat->BumpBitCount[0];
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_RGB) bit_depth = SurfaceDesc->PixelFormat->RGBBitCount[0];
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_YUV) bit_depth = SurfaceDesc->PixelFormat->YUVBitCount[0];

if (NumModes<MAX_MODES)
    {
    Widths[NumModes] = width;
    Heights[NumModes] = height;
    BitDepths[NumModes] = bit_depth;
    RefreshRates[NumModes] = refresh_rate;
    NumModes++;

    ModesListBox->Items->Add( IntToStr(width)+"x"+IntToStr(height)+"x"+IntToStr(bit_depth)+" @ "+IntToStr(refresh_rate)+"Hz" );
    }
else
    Finished = true;
}
//---------------------------------------------------------------------------
